;----------------------;
;---Main-Script-Game---;
;----------------------;

Graphics 800, 600, 16, 2
SetBuffer BackBuffer()

AppTitle "FruitSurvive - Game"
SeedRnd MilliSecs()

Global Timer = CreateTimer(60)

Include "scripts\game\vars.bb"
Include "scripts\game\functions.bb"
Include "scripts\multi types.bb"
Include "scripts\game\buttons.bb"

;Buttons erstellend
Global ButtonLoad = CreateImageButton(350, 230, 100, 30, "gfx\btn_load.png", True)
Global ButtonExit = CreateImageButton(350, 280, 100, 30, "gfx\btn_exit.png", True)

Global ButtonBack = CreateImageButton(350, 550, 100, 30, "gfx\btn_back.png", False)

Global ButtonMenu = CreateImageButton(350, 230, 100, 30, "gfx\btn_menu.png", False)
Global ButtonRest = CreateImageButton(350, 280, 100, 30, "gfx\btn_restart.png", False)

Global ButtonResu = CreateImageButton(350, 280, 100, 30, "gfx\btn_resume.png", False)

;Logos laden
Global Logo = LoadImage("gfx\logo.png")
MaskImage Logo, 255, 0, 255

Global PauseLogo = LoadImage("gfx\pause.png")
MaskImage PauseLogo, 255, 0, 255

Global GameOverLogo = LoadImage("gfx\gameover.png")
MaskImage GameOverLogo, 255, 0, 255

;alle Maps lesen
Dir = ReadDir("maps\")
While True
	Dat$ = NextFile(Dir)		
				
	If Dat$="" Then
		Exit 
	Else If Left(Dat$, 1)<>"."
		CreateTextButton(350, L+20, 100, 20, Dat$, False)
		L = L+30
	End If
Wend

;----------------------------------------------------------------Hauptschleife-----------------------------------------------------------------;

While True
	Cls
	
	;Mauskoordinaten zwischenspeichern
	TempMouseX = MouseX()
	TempMouseY = MouseY()
	
	MouseState = False
	If MouseHit(1) Then MouseState=True:FlushMouse
	
	
	;1 = Men, 2 = Ladebildschirm, 3 = Spiel, 4 = Pausemen, 5 = GameOvermen
	Select GameState
	Case 1
	
		DrawImage Logo, 245, 100
		UpdateImageButton()
		
		If GetButtonState(ButtonLoad) Then DeAktivAllButton(False):DeAktivButton(ButtonBack, True):EnableTextButton(True):GameState = 2
		If GetButtonState(ButtonExit) Then End
	Case 2
		
		UpdateTextButton()
		UpdateImageButton()
		
		
		If GetButtonState(ButtonBack) Then EnableMenuBtns():GameState = 1
		
		TempN$ = GetTextButtonText$()
		
		;Falls GetTextButtonText einen String zurckgiebt Map laden
		If TempN$>"" Then
			EnableGameOverBtns()
			
			CurrMap$ = TempN$
			
			ResetGame()
			LoadMap(TempN$)
			GameState = 3
		End If
	Case 3  
	
		Game()
		
		If Lives=0 Then GameState=5;(GameOver)
		If KeyHit(1) Then EnablePauseBtns():GameState = 4;(Pause)
	Case 4
		
		DrawImage PauseLogo, 323, 100
		UpdateImageButton()
		
		If GetButtonState(ButtonMenu) Then EnableMenuBtns():GameState = 1
		If GetButtonState(ButtonResu) Then EnableGameOverBtns():GameState = 3
	Case 5 
		
		DrawImage GameOverLogo, 279, 100
		UpdateImageButton()
		
		If GetButtonState(ButtonMenu) Then EnableMenuBtns():GameState = 1
		If GetButtonState(ButtonRest) Then ResetGame():LoadMap(CurrMap$):GameState = 3
	End Select		
		
	WaitTimer(Timer)
	Flip(0)
Wend

DestroyAllButtons()

EndGraphics:End

;----------------------------------------------------------------Mainfunktionen----------------------------------------------------------------;

Function Game()

	;Steuerung des Spielers
	If PlayerDir=0 Then
		If KeyDown(17) Then PlayerDir = 1
		If KeyDown(31) Then PlayerDir = 2
		If KeyDown(32) Then PlayerDir = 4
		If KeyDown(30) Then PlayerDir = 3
	End If
	
	;Scrollen
	If PlayerX+16-400>0 Then ScrX = PlayerX+16-400 Else ScrX = 0
	If PlayerY+16-300>0 Then ScrY = PlayerY+16-300 Else ScrY = 0
	
	If ScrX>MapMaxX*32-800+32 Then ScrX = MapMaxX*32-800+32
	If ScrY>MapMaxY*32-600+32 Then ScrY = MapMaxY*32-600+32
	
	;Gegner erstellen
	CreateNewEn()
		
	;Schsse, Ki, Waffen und Waffenfelder aktualisieren	
	RenderShot()
	RenderGranads()
	DrawMap()
	UpdatePlayer()
	UpdateWeapon()
	WeaponFields()
	
	;Spieler normal zeichen, wenn er getroffen wurde blinkend zeichnen
	If Hit=False Then 
		DrawImage Player, PlayerX-ScrX,PlayerY-ScrY
	Else
		HitTimer = HitTimer-1
		If HitTimer=0 Then Hit = False:HitTimer = 100
		
		If HitTimer Mod 20=0 Then DrawImage Player, PlayerX-ScrX,PlayerY-ScrY
	End If
	
	RenderKi()
	
	Text 40, 40, "Level "+ Level
	Text 40, 55, "Lebel "+Lives
	Text 40, 70, "Punkte "+ Points

	
	For M.Message = Each Message
		
		Text 400, 300, M\Msg$, True, True
		M\Lives = M\Lives-1
		If M\Lives = 0 Then Delete M
		
	Next
	
	If KeyHit(16) Then FlushKeys
End Function

;-----------------------------------------------------------------------;

Function EnableMenuBtns()
	DeAktivAllButton(False)
	
	DeAktivButton(ButtonLoad, True)
	DeAktivButton(ButtonExit, True)
End Function

Function EnablePauseBtns()
	DeAktivAllButton(False)
	
	DeAktivButton(ButtonMenu, True)
	DeAktivButton(ButtonResu, True)
End Function

Function EnableGameOverBtns()
	DeAktivAllButton(False)
	
	DeAktivButton(ButtonMenu, True)
	DeAktivButton(ButtonRest, True)
End Function