;----------------------------------;
;---Alle notwendigen Funktionen;---;
;----------------------------------;

Dim Map(1,1)

Dim WeaponSlot(1, 1)
Dim WeaponAmmo(4)
Dim WeaponCoasts(4, 1)
Dim WeaponRage(4)

;Magazin gre
WeaponAmmo(0) = 100
WeaponAmmo(1) = 75
WeaponAmmo(2) = 70
WeaponAmmo(3) = 300
WeaponAmmo(4) = 6

;Kosten der Waffen und Munition

;Waffenkosten
WeaponCoasts(0, 0) = 600
WeaponCoasts(1, 0) = 1500
WeaponCoasts(2, 0) = 1800
WeaponCoasts(3, 0) = 2300
WeaponCoasts(4, 0) = 150

;Munitionkosten
WeaponCoasts(0, 1) = 200
WeaponCoasts(1, 1) = 300
WeaponCoasts(2, 1) = 250
WeaponCoasts(3, 1) = 320
WeaponCoasts(4, 1) = 150

;Waffen Strke
WeaponRage(0) = 1
WeaponRage(1) = 2
WeaponRage(2) = 2
WeaponRage(3) = 3
WeaponRage(4) = 0

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function DrawMap()
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			If Map(X,Y)>0 Then DrawImage Tileset, X*32-ScrX, Y*32-ScrY, Map(X, Y)-1
		Next
	Next
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Setzt das gesammte Spiel zurck
Function ResetGame()
	For S.SpawnPoint=Each SpawnPoint
		Delete S
	Next
	For Sw.Switch=Each Switch
		Delete Sw
	Next
	For E.Enemies=Each Enemies
		Delete E
	Next
	For Sh.Shot=Each Shot
		Delete Sh
	Next
	
	Points = 1000
	Lives  = 10
	
	;WaffenSlots zurcksetzen
	Dim WeaponSlot(1,1)
	WeaponSlot(0, 0) = 1  ;Waffen Typ
	WeaponSlot(0, 1) = 100;Munition
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function UpdatePlayer()
	;1 = Hoch(W), 2 = Runter(S), 3 = Links(A), 4 = Rechts(D)
	Select PlayerDir
	Case 1
		If Map((PlayerX+16)/32, (PlayerY-1)/32)=0 Or Map((PlayerX+16)/32, (PlayerY-1)/32)>18 Then PlayerY = PlayerY-4 Else PlayerDir = 0
	Case 2
		If Map((PlayerX+16)/32, PlayerY/32+1)=0 Or Map((PlayerX+16)/32, PlayerY/32+1)>18 Then PlayerY = PlayerY+4 Else PlayerDir = 0
	Case 3
		If Map((PlayerX-1)/32, (PlayerY+16)/32)=0 Or Map((PlayerX-1)/32, (PlayerY+16)/32)>18 Then PlayerX = PlayerX-4 Else PlayerDir = 0
	Case 4
		If Map(PlayerX/32+1, (PlayerY+16)/32)=0 Or Map(PlayerX/32+1, (PlayerY+16)/32)>18 Then PlayerX = PlayerX+4 Else PlayerDir = 0
	End Select
	
	If PlayerDir=3 Or PlayerDir=4 Then
		If PlayerX Mod 32=0 Then PlayerDir=0
	Else If PlayerDir=1 Or PlayerDir=2 Then
		If PlayerY Mod 32=0 Then PlayerDir=0
	End If
	
	;Wenn der Spieler auf einem Schalter ist dessen Kosten anzeigen
	For S.Switch=Each Switch
		If RectsOverlap(PlayerX, PlayerY, 32, 32, S\X*32, S\Y*32, 32, 32) Then
			Text 400, 250, S\Coasts+" (Q)", True, False
			
			;Auf Q-druck freischalten, wenn man genug Punkte besitzt
			If KeyHit(16) And Points>=S\Coasts Then Points = Points-S\Coasts:Map(S\DoorX, S\DoorY) = 0:Delete S:FlushKeys
		End If
	Next
	
	If Map((PlayerX+16)/32, (PlayerY+16)/32)=24 Then 
		
		Text PlayerX+16-ScrX, PlayerY+45-ScrY, "Waffen Update", True, False
		Text PlayerX+16-ScrX, PlayerY+60-ScrY, "3000", True, False
		
		If KeyHit(16) And Points>=3000 And WeaponSlot(CurrWeapon, 0)<>5 Then 
			Points = Points-2000
			
			T=Rand(5, 7)
			
			WeaponRage(WeaponSlot(CurrWeapon, 0)-1) = WeaponRage(WeaponSlot(CurrWeapon, 0)-1)+T
			
			M.Message = New Message
			M\Msg$ = "Strke +"+T
			M\Lives = 100
		End If
	End If
	
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function UpdateWeapon()

	;Zwischen den Waffen wechseln
	Select MouseZSpeed()
	Case -1
		If CurrWeapon>0 Then CurrWeapon = CurrWeapon-1
	Case 1
		If CurrWeapon<1 Then CurrWeapon = CurrWeapon+1
	End Select
	
	;Info auf den Bildschirm schreiben
	
	For I=0 To 1
		If WeaponSlot(I, 0)>0 Then 
			DrawImage Tileset, 700+I*43, 40, WeaponSlot(I, 0)+17
			Text 700+I*43, 70, WeaponSlot(I, 1)
		Else
			Text 700+I*43, 60, "Leer", False, True			
		End If
	Next
	
	Color 0, 0, $FF0000
	Rect 695+CurrWeapon*43, 37, 45, 50, False 
	Color 0, 0, $FFFFFF
		
	;Schusswinkel berechnen lassen
	Angle# = (ATan2(Float#( (PlayerY+16-ScrY)-TempMouseY), Float#(TempMouseX-(PlayerX+16-ScrX)))+360) Mod 360
	
	;Alle wafen auser der MaisMG suf Mausklick, MaisMG mit Mausgedrckt
	If WeaponSlot(CurrWeapon, 0)<>4 Then
		If MouseState=1 And WeaponSlot(CurrWeapon, 1)>0 And WeaponSlot(CurrWeapon, 0)>0 Then 
			WeaponSlot(CurrWeapon, 1) = WeaponSlot(CurrWeapon, 1)-1
			
			;Waffe 1 = Apfelkern, Waffe 2 = Kirschsplitterkern, Waffe 3 = Erbsen 3-Schussgewehr
			Select WeaponSlot(CurrWeapon, 0)
			Case 1
			
				;Einfacher schuss
				CreateShot(Angle#, PlayerX+16, PlayerY+16, 200, 1, WeaponRage(WeaponSlot(CurrWeapon, 0)-1))
			Case 2
				
				;2 Schsse nebeneinander mit unterschiedlichem Winkel
				For X#=-4 To 4 Step 8
					CreateShot(Angle#+X#, PlayerX+16, PlayerY+16, 100, 2, WeaponRage(WeaponSlot(CurrWeapon, 0)-1))
				Next
			Case 3
				
				;3 Schsse hintereinander
				For X=3 To 1 Step -1
					CreateShot(Angle#, PlayerX+16+X*20*Cos(Angle#), PlayerY+16-X*20*Sin(Angle), 160, 3, WeaponRage(WeaponSlot(CurrWeapon, 0)-1))
				Next
			Case 5
				
				CreateGranade(Angle#, PlayerX-16, PlayerY-16)
			End Select
		End If
	Else
		
		;Timer bis zum nchsten Schuss runter zhlen
		If ShotTimer>0 Then ShotTimer = ShotTimer-1
	
		;wenn dieser 0 ist, Munition da ist und die Mausgeklickt wurde Timer zurcksetzen und einen Schuss abgeben
		If MouseDown(1) And ShotTimer<=0 And WeaponSlot(CurrWeapon, 1)>0 Then
			ShotTimer = 10
				
			WeaponSlot(CurrWeapon, 1) = WeaponSlot(CurrWeapon, 1)-1
			CreateShot(Angle#, PlayerX+16, PlayerY+16, 220, 4, WeaponRage(WeaponSlot(CurrWeapon, 0)-1))
		End If
	End If
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Die Waffenfelder auf welchen man Munition und Waffen kaufen kann
Function WeaponFields()
	Local WeaponField = Map(PlayerX/32, PlayerY/32)-19
	Local AmmoTo

	If Map(PlayerX/32, PlayerY/32)>18 And Map(PlayerX/32, PlayerY/32)<24 Then
		
		If PlayerY+75-ScrY<600 Then 
			Text PlayerX+16-ScrX, PlayerY+45-ScrY, "Waffe "+WeaponCoasts(WeaponField, 0), True, False
			Text PlayerX+16-ScrX, PlayerY+60-ScrY, "Munition "+WeaponCoasts(WeaponField, 1), True, False
			Text PlayerX+16-ScrX, PlayerY+75-ScrY, "Strke "+WeaponRage(WeaponField), True, False
		Else
			Text PlayerX+16-ScrX, PlayerY-45-ScrY, "Waffe "+WeaponCoasts(WeaponField, 0), True, False
			Text PlayerX+16-ScrX, PlayerY-30-ScrY, "Munition "+WeaponCoasts(WeaponField, 1), True, False
			Text PlayerX+16-ScrX, PlayerY-15-ScrY, "Strke "+WeaponRage(WeaponField), True, False
		End If
		
		;Checken, ob man sich die Waffe leisten
		If KeyHit(16) Then
			
			;Gucken ob die Waffe bereits exestiert
			For I=0 To 1
				If WeaponSlot(I, 0)=WeaponField+1 Then AmmoTo = I+1
			Next
			
			;Waffe kaufen wenn sie nochnicht exestiert
			If Points>WeaponCoasts(WeaponField, 0) Then			
				If AmmoTo=0 Then 
					WeaponSlot(CurrWeapon, 0) = WeaponField+1
					WeaponSlot(CurrWeapon, 1) = WeaponAmmo(WeaponField)
					Points = Points-WeaponCoasts(WeaponField, 0)
					Buy=True
				End If
			End If
			
			;sonst nur Munition
			If Points>WeaponCoasts(WeaponField, 1) And Buy=False Then
				If AmmoTo>0 Then 
					WeaponSlot(AmmoTo-1, 1) = WeaponAmmo(WeaponField)
					Points = Points-WeaponCoasts(WeaponField, 1)
				End If
			End If
		End If
	End If
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Neuen Feind erstellen
Function CreateNewEn()
	Local TempX
	Local TempY
	
	;Nach zuflliger Zeit ein Monster spawnen lassen
	If Rand(0,100)=30 Then
		
		;Zuflligen Spawnpoint auswhlen
		For S.SpawnPoint=Each SpawnPoint 
			If S\ID=Rand(1,TotalSpawnPoints) And S\Le<=Level Then
				
				;Monster erstellen
				If TotalEnOnLev<MaxEnOnLev Then
					E.Enemies = New Enemies
					E\ID	  = Handle(E)
					E\X	  	  = S\X*32
					E\Y	 	  = S\Y*32
					E\EType   = Level
					E\Lives   = 2*E\EType
					
					EnOnMap		 = EnOnMap+1
					TotalEnOnLev = TotalEnOnLev+1
				Else
					If EnOnMap<=0 Then Level = Level+1:MaxEnOnLev = MaxEnOnLev+5:TotalEnOnLev = 0
				End If
			End If
		Next
	End If
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Erstellt einen neuen Schuss
Function CreateShot(A#, X#, Y#, D, T, R)
	S.Shot   = New Shot
	S\X# 	 = X#
	S\Y#	 = Y#
	S\Angle# = A#
	
	S\Speed# = 5
	
	S\Distance = D/Int(S\Speed#)
	S\SType    = T
	S\Rage	   = R
End Function

Function CreateGranade(A#, X#, Y#)
	G.Granade = New Granade
	
	G\X# = X#
	G\Y# = Y#
	
	G\Angle#   = A#
	G\Distance = 120
	
	G\Timer = 20
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Rendert alle Schsse
Function RenderShot()	
	For S.Shot = Each Shot
		
		If S\SType<5 Then
			DrawImage Ammo_Png, S\X#-ScrX, S\Y#-ScrY, S\SType-1
		Else
			DrawImage Rocket, S\X#-ScrX, S\Y#-ScrY
		End If
		
		;Position ndern
		S\X# = S\X#+Cos(S\Angle#)*S\Speed
		S\Y# = S\Y#-Sin(S\Angle#)*S\Speed
		
		S\Distance = S\Distance-1
		
		;Falls ein Schuss die Wand berhren solte diesen lschen
		If Map(Int(S\X#)/32, Int(S\Y#)/32)>0 Or S\Distance=0 Then Delete S:Exit
		
		;Falls ein gegner getroffen wurde
		For En.Enemies=Each Enemies
			If RectsOverlap(S\X#, S\Y#, 5, 5, En\X, En\Y, 32, 32) Then
			
				En\Lives = En\Lives-S\Rage
				Points 	 = Points+15
				If En\Lives<=0 Then 
					Points  = Points+25
					EnOnMap = EnOnMap-1
					Delete En
				End If
			
				Delete S
				Exit
			End If
		Next
	Next
End Function

;Alle Granaten zeichnen
Function RenderGranads()
	For G.Granade = Each Granade
		DrawImage Tileset, G\X#-ScrX, G\Y#-ScrY, 22
	
		If G\Distance>0 Then
			
			If Map((Int(G\X#)+16)/32, Int(G\Y#)/32+1)=0 And Map((Int(G\X#)+16)/32, (Int(G\Y#)-1)/32)=0 And Map(Int(G\X#)/32+1, (Int(G\Y#)+16)/32)=0 And Map((Int(G\X#)-1)/32, (Int(G\Y#)+16)/32)=0 Then
				G\X# = G\X#+Cos(G\Angle#)*7		
				G\Y# = G\Y#-Sin(G\Angle#)*7
			End If
			
			G\Distance = G\Distance-7
		Else
		
			G\Timer = G\Timer-1
			If G\Timer<=0 Then
				DrawImage Explosion, G\X#-25-ScrX, G\Y#-25-ScrY
				
				For Ene.Enemies = Each Enemies
					If RectsOverlap(Ene\X, Ene\Y, 32, 32, G\X#-25, G\Y#-25, 100, 100) Then
						Points = Points+25
						Delete Ene
						EnOnMap = EnOnMap-1
					End If
				Next
				
				If G\Timer=-10 Then Delete G
			End If
		End If
	Next
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Alle Bots aktualisieren
Function RenderKi()	
	For E.Enemies=Each Enemies		
		If RectsOverlap(E\X, E\Y, 32, 32, PlayerX-250, PlayerY-250, 466, 466) Then 
			If Not E\Follow Then E\Follow = True
		Else 
			If E\Follow Then E\Follow = False
		End If
		
		If E\IsOnWay=False Then
			If E\Follow=False Then	
				
				;Weg und Richtung durch Zufall festlegen
				E\Dir	   = Rand(1, 4)
				E\Distance = Rand(0, 10)*32					
			Else
				
				;Spieler folgen
				If E\X<PlayerX Then
					If Map(E\X/32+1, (E\Y+16)/32)=0 Or Map(E\X/32+1, (E\Y+16)/32)>18 Then 
						E\Dir = 1 
					Else 
						If Map((E\X+16)/32, (E\Y-1)/32)=0 Or Map((E\X+16)/32, (E\Y-1)/32)>18 Then E\Dir = 4
						If Map((E\X+16)/32, E\Y/32+1)=0 Or Map((E\X+16)/32, E\Y/32+1)>18 Then E\Dir = 2
					End If
				Else If E\X>PlayerX Then
					If Map((E\X-1)/32, (E\Y+16)/32)=0 Or Map((E\X-1)/32, (E\Y+16)/32)>18 Then 
						E\Dir = 3
					Else 
						If Map((E\X+16)/32, (E\Y-1)/32)=0 Or Map((E\X+16)/32, (E\Y-1)/32)>18 Then E\Dir = 4
						If Map((E\X+16)/32, E\Y/32+1)=0 Or Map((E\X+16)/32, E\Y/32+1)>18 Then E\Dir = 2
					End If
				Else				
					If E\Y>PlayerY Then
						If Map((E\X+16)/32, (E\Y-1)/32)=0 Or Map((E\X+16)/32, (E\Y-1)/32)>18 Then 
							E\Dir = 4
						Else 
							If Map((E\X-1)/32, (E\Y+16)/32)=0 Or Map((E\X-1)/32, (E\Y+16)/32)>18 Then E\Dir = 3
							If Map(E\X/32+1, (E\Y+16)/32)=0 Or Map(E\X/32+1, (E\Y+16)/32)>18 Then E\Dir = 1
						End If
					End If
					
					If E\Y<PlayerY Then
						If Map((E\X+16)/32, E\Y/32+1)=0 Or Map((E\X+16)/32, E\Y/32+1)>18 Then 
							E\Dir = 2 
						Else 
							If Map((E\X-1)/32, (E\Y+16)/32)=0 Or Map((E\X-1)/32, (E\Y+16)/32)>18 Then E\Dir = 3
							If Map(E\X/32+1, (E\Y+16)/32)=0 Or Map(E\X/32+1, (E\Y+16)/32)>18 Then E\Dir = 1
						End If
					End If
				End If
				
				E\Distance = 32			
			End If
			
			E\IsOnWay  = True
		End If
		
		;Bewegen und wenn der weg zuende ist oder an eine Wand gestoen ist Bewegung beenden
		
		;3 = Links, 1 = Rechts, 4 = Hoch, 2 = Runter
		If E\IsOnWay=True Then
			Select E\Dir
			Case 3
				If Map((E\X-1)/32, (E\Y+16)/32)>0 And Map((E\X-1)/32, (E\Y+16)/32)<19 Then E\IsOnWay = False Else E\X = E\X-2
			Case 1
				If Map(E\X/32+1, (E\Y+16)/32)>0 And Map(E\X/32+1, (E\Y+16)/32)<19 Then E\IsOnWay = False Else E\X = E\X+2
			Case 4
				If Map((E\X+16)/32, (E\Y-1)/32)>0 And Map((E\X+16)/32, (E\Y-1)/32)<19 Then E\IsOnWay = False Else E\Y = E\Y-2
			Case 2
				If Map((E\X+16)/32, E\Y/32+1)>0 And Map((E\X+16)/32, E\Y/32+1)<19 Then E\IsOnWay = False Else E\Y = E\Y+2
			End Select
				
			E\Distance = E\Distance-2
			If E\Distance=0 Then E\IsOnWay = False
		End If
		
		;wenn ein Gegner den Spieler trifft diesem ein Leben abziehen
		If RectsOverlap(E\X, E\Y, 32, 32, PlayerX, PlayerY, 32, 32) And Hit=False Then
			Hit   = True
			Lives = Lives-1
		End If	
		
		DrawImage Enemy_Png, E\X-ScrX, E\Y-ScrY, E\Dir-1
	Next	
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function LoadMap(File$)
	;Datei zum Lesen ffnen
	FileIn = OpenFile("maps\"+File$)
	
	;berprfen ob die Map zum Spiel gehhrt
	If Not ReadString(FileIn)="Map fuer FruitSurvive" Then RuntimeError "Falscher Maptyp"
	
	;Karten gre lesen
	MapMaxX = ReadInt(FileIn)
	MapMaxY = ReadInt(FileIn)
	Dim Map(MapMaxX, MapMaxY)
	
	;Zu nutzendes Tileset ffnen
	TS = ReadByte(FileIn)
	FreeImage Tileset
	Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+".png", 32, 32, 0, 24)
	MaskImage Tileset, 255, 0, 255
	
	;Playerposition einstellen
	PlayerX = ReadInt (FileIn)
	PlayerY = ReadInt (FileIn)
	PlayerS = ReadByte(FileIn)
	
	;Kartendaten einlesen
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			Map(X, Y) = ReadByte(FileIn)
		Next
	Next
	
	;Spawnpoints erstellen
	TotalSpawnPoints = ReadByte(FileIn)
	For X=0 To TotalSpawnPoints-1
		S.SpawnPoint = New SpawnPoint
			
		S\ID = ReadByte(FileIn)+C
		S\X  = ReadInt (FileIn)
		S\Y  = ReadInt (FileIn)
		S\Le = ReadByte(FileIn)
		
		C=C+1
	Next
	
	;Schalter erstellen
	TotalSwitch = ReadByte(FileIn)
	For X=0 To TotalSwitch-1
		Sw.Switch= New Switch
		
		Sw\DoorX = ReadInt(FileIn)
		Sw\DoorY = ReadInt(FileIn)
		Sw\X	 = ReadInt(FileIn)
		Sw\Y	 = ReadInt(FileIn)
		Sw\Coasts= ReadInt(FileIn)
	Next
	
	;Datei schlieen
	CloseFile(FileIn)
End Function