﻿
Type TEnemy
	Field x:Float, y:Float, p:Int
	Field img:TImage
	Field active:Int, respawntime:Int
	
	Global List:TList[] = [New TList, New TList, New TList]
	
	Method Draw(_z:Int)
		SetScale(Scale[_z], Scale[_z])
		DrawImage(Self.img, Self.x + Scroll * Scale[_z], Self.y)
	End Method
	
	Method Move() Abstract
	
	Method GetHit() Abstract
	
	Function DrawAll(_z:Int)
		For Local E:TEnemy = EachIn TEnemy.List[_z]
		
			If E.active = False Then
				If E.respawntime < ms Then E.active = True
			Else
				E.Move()
				E.Draw(_z)
			EndIf
			
			If (E.x + Scroll * Scale[_z]) < (-gfx_w * 0.3) Or (E.x + Scroll * Scale[_z]) > (gfx_w * 1.3) Then
				E.GetHit()
				TEnemy.List[_z].Remove(E)
			EndIf
			
			If TChicken.c < TChicken.cmax Then
				Local k:Int[] = [Int(-gfx_w * 0.2), Int(gfx_w * 1.2)]
				Local r:Int = Rand(0, 1)
				TChicken.Create(k[r], Rand(64, gfx_h *.8), Rand(0, 2))
			EndIf
			
		Next
		SetScale(1, 1)
	End Function
	
	Function Generate()
	
		'*Pilze hinten
		TMushroom.Create(gfx_w *.6, gfx_h *.65, 0)
		TMushroom.Create(gfx_w *.64, gfx_h *.68, 0)
		TMushroom.Create(gfx_w *.57, gfx_h *.69, 0)
		TMushroom.Create(gfx_w *.62, gfx_h *.73, 0)
		
		'*Baum Links hinten
		TCherry.Create(gfx_w *.25, gfx_h *.5, 0)
		TCherry.Create(gfx_w *.32, gfx_h *.35, 0)
		TCherry.Create(gfx_w *.28, gfx_h *.44, 0)
		TCherry.Create(gfx_w *.26, gfx_h *.37, 0)
		
		'*Baum Links
		TCherry.Create(gfx_w * -.1, gfx_h *.48, 1)
		TCherry.Create(gfx_w * -.05, gfx_h *.46, 1)
		TCherry.Create(gfx_w * 0.01, gfx_h *.38, 1)
		TCherry.Create(gfx_w * -.04, gfx_h *.35, 1)
		TCherry.Create(gfx_w * -.09, gfx_h *.36, 1)
		
		'*Karroten Hügel
		TCarrot.Create(gfx_w *.45, gfx_h *.5, 1)
		TCarrot.Create(gfx_w *.3, gfx_h *.8, 1)
		TCarrot.Create(gfx_w *.4, gfx_h *.72, 1)
		TCarrot.Create(gfx_w *.35, gfx_h *.55, 1)
		TCarrot.Create(gfx_w *.31, gfx_h *.65, 1)
		TCarrot.Create(gfx_w *.39, gfx_h *.83, 1)
		TCarrot.Create(gfx_w *.28, gfx_h *.84, 1)
		
		'Baum hinten
		TApple.Create(gfx_w * 1.0, gfx_h *.4, 1)
		TApple.Create(gfx_w * 1.1, gfx_h *.3, 1)
		TApple.Create(gfx_w * 1.08, gfx_h *.44, 1)
		TApple.Create(gfx_w * 1.05, gfx_h *.35, 1)
		TApple.Create(gfx_w * 1.02, gfx_h *.31, 1)
		
		'Baum Rechts
		TApple.Create(gfx_w *.72, gfx_h *.60, 2)
		TApple.Create(gfx_w *.79, gfx_h *.48, 2)
		TApple.Create(gfx_w *.74, gfx_h *.35, 2)
		TApple.Create(gfx_w *.85, gfx_h *.55, 2)
		
		'*Pilze Vorne
		TMushroom.Create(gfx_w *.07, gfx_h *.92, 2)
		TMushroom.Create(gfx_w *.05, gfx_h *.95, 2)
		TMushroom.Create(gfx_w *.04, gfx_h *.9, 2)
		
		'*Karroten Vorne
		TCarrot.Create(gfx_w *.9, gfx_h *.8, 2)
		TCarrot.Create(gfx_w *.95, gfx_h *.87, 2)
		TCarrot.Create(gfx_w *.98, gfx_h *.89, 2)
		TCarrot.Create(gfx_w * 1.05, gfx_h *.78, 2)
		TCarrot.Create(gfx_w *.96, gfx_h *.77, 2)
		
		TChicken.Create(-gfx_w * 0.1, gfx_h *.2, 0)
		TChicken.Create(gfx_w * 1.1, gfx_h *.25, 0)
		
	End Function
	
	Function Clear()
		For Local l:TList = EachIn TEnemy.List
			l.Clear()
		Next
	End Function
	
End Type


Type TMushroom Extends TEnemy

	Method ToString:String()
		Return "Pilz"
	End Method

	Function Create:TMushroom(_x:Float, _y:Float, _z:Int)
		Local E:TMushroom = New TMushroom
			E.x = _x
			E.y = _y
			E.img = Pilz
			E.p = 2
			TEnemy.List[_z].AddLast(E)
			E.active = True
		Return E
	End Function
		
	Method GetHit()
		Self.active = False
		Self.respawntime = ms + 1000 * Rand(3, 8)
	End Method
	
	Method Move()
		Return
	End Method

End Type

Type TCherry Extends TEnemy

	Method ToString:String()
		Return "Kirsche"
	End Method

	Function Create:TCherry(_x:Float, _y:Float, _z:Int)
		Local E:TCherry = New TCherry
			E.x = _x
			E.y = _y
			E.img = Krische
			E.p = 5
			TEnemy.List[_z].AddLast(E)
			E.active = True
		Return E
	End Function
		
	Method GetHit()
		Self.active = False
		Self.respawntime = ms + 1000 * Rand(6, 12)
	End Method
	
	Method Move()
		Return
	End Method

End Type

Type TApple Extends TEnemy
	
	Method ToString:String()
		Return "Apfel"
	End Method

	Function Create:TApple(_x:Float, _y:Float, _z:Int)
		Local E:TApple = New TApple
			E.x = _x
			E.y = _y
			E.img = Apfel
			E.p = 20
			TEnemy.List[_z].AddLast(E)
			E.active = True
		Return E
	End Function
		
	Method GetHit()
		Self.active = False
		Self.respawntime = ms + 1000 * Rand(20, 30)
	End Method
	
	Method Move()
		Return
	End Method

End Type

Type TCarrot Extends TEnemy

	Method ToString:String()
		Return "Karotte"
	End Method

	Function Create:TCarrot(_x:Float, _y:Float, _z:Int)
		Local E:TCarrot = New TCarrot
			E.x = _x
			E.y = _y
			E.img = Karotte
			E.p = 20
			TEnemy.List[_z].AddLast(E)
			E.active = True
		Return E
	End Function
		
	Method GetHit()
		Self.active = False
		Self.respawntime = ms + 1000 * Rand(20, 30)
	End Method
	
	Method Move()
		Return
	End Method

End Type

Type TChicken Extends TEnemy

	Field r:Int, s:Float
	Global c:Int, cmax:Int = 5

	Method ToString:String()
		Return "Huhn"
	End Method

	Function Create:TChicken(_x:Float, _y:Float, _z:Int)
		Local E:TChicken = New TChicken
			E.x = _x
			E.y = _y
			E.img = Huhn
			If _x < gfx_w *.5 Then
				E.r = 1
			Else
				E.r = -1
			EndIf
			E.s = 1.5 * (_z + 1)
			E.p = 20
			TEnemy.List[_z].AddLast(E)
			E.active = -1
			TChicken.c:+1
		Return E
	End Function
	
	Method Draw(_z:Int)
		SetScale(Self.r * Scale[_z], Scale[_z])
		DrawImage(Self.img, Self.x + Scroll * Scale[_z], Self.y)
	End Method
		
	Method GetHit()
		TChicken.c:-1
	End Method
	
	Method Move()
		Self.x:+Self.r * Self.s
	End Method

End Type

