﻿
Type TGun Abstract

	Field Mag:Int, MagMax:Int '* Munition
	Field Time:Int
	Field FireDelay:Int '* Zeit zwischen zwei Schüssen
	Field ReloadDelay:Int '* Zeit zum nachladen
	Field img:TImage
	
	Method Draw() Abstract
	
	Method Fire(_x:Int, _y:Int)
		For Local i:Int = Scale.length - 1 To 0 Step - 1
		
			If i < Scale.length Then
				'Print("Test Enemy [" + i + "]")
				For Local E:TEnemy = EachIn TEnemy.List[i]
					If E.active = False Then Continue
					'* Beachtung von Position & Skalierung 
					If PosInRect(_x, _y, (E.x + Scroll * Scale[i]) - (E.img.width * Scale[i]) / 2, E.y - (E.img.height * Scale[i]) / 2, E.img.width * Scale[i], E.img.height * Scale[i]) Then
						Points:+((1.0 / Scale[i]) * E.p)
						If E.active = -1 Then
							E.GetHit()
							TEnemy.List[i].Remove(E)
						Else
							E.GetHit()
						EndIf
						TRecipe.Akt.Get(E.ToString())
						
						'Print("Treffer [" + i + "]")
					EndIf
					
				Next
			EndIf
			
			'* Falls der Hintergrund getroffen wird...
			If i > 0 Then
				'Print("Test BG [" + i + "]")
				If ImagesCollide(BG, gfx_w *.5 + Scroll * Scale[i], gfx_h *.5, i, CollPix, mx, my, 0) Then
					'Print("Hit BG [" + i + "]")
					Return
				EndIf
			EndIf
			
		Next
	End Method
	
	Method Reload()
		If Self.Mag < Self.MagMax Then
			Self.Mag = Self.MagMax
			Play_Sound(Snd_reload)
		EndIf
	End Method
	
End Type

Type TGun_Cherry Extends TGun

	Function Create:TGun_Cherry()
		Local G:TGun_Cherry = New TGun_Cherry
			G.img = LoadImage("Data/gfx/Cherry.png")
			G.MagMax = 8
			G.Mag = G.MagMax
			G.ReloadDelay = 2500
		Return G
	End Function
	
	Method Draw()
		SetColor(128, 128, 125)
		For Local i:Int = 0 Until Self.MagMax
			DrawImage(Self.img, gfx_w - Self.img.width * (i + 1), gfx_h - Self.img.height)
		Next
		
		SetColor(255, 255, 255)
		For Local i:Int = 0 Until Self.Mag
			DrawImage(Self.img, gfx_w - Self.img.width * (i + 1), gfx_h - Self.img.height)
		Next
	End Method
	
	Method Fire(_x:Int, _y:Int)
		If Self.Mag > 0 Then
			Super.Fire(_x, _y)
			Self.Mag:-1
			Play_Sound(Snd_peng)
		Else
			Play_Sound(Snd_noshot)
		EndIf
	End Method

End Type
