﻿
Type THighscore

	Field Name:String, Points:Int
	
	Global List:TList = New TList
	Global LastEntry:THighscore
	Const FilePath:String = "Data/High.Score"
	
	Function Add(_name:String, _points:Int)
		Local H:THighscore = New THighscore
		H.Name = _name
		H.Points = _points
		THighscore.List.AddFirst(H)	'* Neue Einträge stehen weiter oben in der Liste
		THighscore.List.Sort() '* Sort() benutzt die Compare-Methode des Objekts, siehe unten
		THighscore.LastEntry = H
	End Function
	
	Method Compare:Int(withObject:Object)
		Local H2:THighscore = THighscore(withObject)
		Return H2.Points - Self.Points
	End Method
	
	Method ToString:String()
		Return Self.Name + " ~~ " + Self.Points
	End Method
	
	Function Save()
		Local File:TStream = WriteStream(THighscore.FilePath)
		Local i:Int = 0
		
		For Local H:THighscore = EachIn THighscore.List
			i:+1
			File.WriteLine(H.Name)
			File.WriteInt(H.Points)
			If i = 10 Then Exit
		Next
		
		File.Close()
	End Function
	
	Function Load()
		Local File:TStream = ReadStream(THighscore.FilePath)
		If Not(File) Then THighscore.Fill() ; Return
	
		While Not(File.Eof())
			Local n:String = File.ReadLine()
			Local p:Int = File.ReadInt()
			THighscore.Add(n, p)
		Wend
		THighscore.LastEntry = Null
		
		File.Close()
	End Function
	
	Function Fill()
		For Local i:Int = 0 Until 10
			THighscore.Add("Xeres", i * i * 15 + i * 10 + 10)
		Next
		THighscore.LastEntry = Null
	End Function
	
	Function Draw()
		Local i:Int = 0
		For Local H:THighscore = EachIn THighscore.List
			i:+1
			Local y:Int = gfx_h *.025 + gfx_h *.07 * i
			If THighscore.LastEntry = H Then
				SetColor(64, 200, 64)
				DrawRect(gfx_w *.2, y - 16, gfx_w *.6, 32)
				SetColor(0, 0, 0)
			Else
				SetColor(255, 255, 255)
			EndIf
			DrawText(i + ".", gfx_w *.25, y, 1)
			DrawText(H.Name, gfx_w *.5, y)
			DrawText(H.Points, gfx_w *.77, y, 1)
			If i = 10 Then Exit
		Next
		SetColor(255, 255, 255)
	End Function

End Type
