﻿
Type TRecipe
	Field Name:String
	Field Source:String[]
	Field Zutaten:String[]
	Field Reaktion()
	
	Global Akt:TRecipe '* Aktives Rezept
	Global List:TList = New TList '* Alle Rezepte
	
	Method New()
		List.AddLast(Self)
	End Method
	
	Function Create:TRecipe(_name:String, _z:String[], _r())
		Local R:TRecipe = New TRecipe
			R.Name = _name
			R.Source = _z
			R.Reaktion = _r
		Return R
	End Function
	
	Function Random:TRecipe()
		Local N:Int = Rand(0, TRecipe.List.Count() - 1)
		For Local R:TRecipe = EachIn TRecipe.List
			If N = 0 Then
				R.Zutaten = R.Source
				TRecipe.Akt = R
			EndIf
			N:-1
		Next
	End Function
	
	Method Get(_z:String)
		If Self.Zutaten[Self.Zutaten.Length - 1] = _z Then
			Self.Zutaten = Self.Zutaten[..Self.Zutaten.Length - 1]
			If Self.Zutaten.Length = 0 Then
				Self.Reaktion()
				TRecipe.Random()
			EndIf
		EndIf
	End Method
	
	Method Draw()
		Local s:String = Self.Zutaten[Self.Zutaten.Length - 1] + " (" + Int(100 - (Self.Zutaten.Length * 100.0 / Float(Self.Source.Length))) + "%)"
		SetAlpha(0.66)
		SetColor(96, 96, 96)
		DrawRect(24, gfx_h - 48, gfx_w *.28 + TextWidth(s), 32)
	
		SetAlpha(1)
		SetColor(64, 64, 64)
		DrawText(Self.Name + ": ", 32, gfx_h - 32, 0)
		DrawText(s, gfx_w *.33, gfx_h - 32)
	End Method

End Type

TRecipe.Create("Pilz-Suppe", ["Pilz", "Pilz", "Apfel", "Karotte", "Pilz", "Pilz"], R_Time)
TRecipe.Create("Hühnerbrühe", ["Huhn", "Karotte", "Karotte", "Huhn", "Huhn", "Apfel", "Huhn"], R_Chickens)
TRecipe.Create("Frucht-Punsch", ["Kirsche", "Kirsche", "Apfel", "Kirsche", "Apfel", "Apfel"], R_Time)
TRecipe.Create("Gemüsebrühe", ["Karotte", "Karotte", "Apfel", "Karotte", "Pilz", "Pilz", "Pilz", "Pilz", "Apfel", "Karotte"], R_Time2)

Function R_Time()
	Time:+10000
	Points:+500
End Function

Function R_Time2()
	Time:+5000
	Points:+1500
End Function

Function R_Chickens()
	TChicken.cmax:*1.2
	Points:+1000
End Function
