SuperStrict

Include "Include/Extras.bmx"
Include "Include/Optionen.bmx"
Include "Include/THighscore.bmx"
Include "Include/TEnemy.bmx"
Include "Include/TGun.bmx"
Include "Include/TRecipe.bmx"

AppTitle = "SoupCraft"
Global gfx_w:Int = 1024
Global gfx_h:Int = 512
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
HideMouse()
Local Frametimer:TTimer = TTimer.Create(60)

Global mx:Int, my:Int, mh1:Int, mh2:Int, md1:Int, md2:Int, ms:Float

Const GS_MainMenu:Int = 0, GS_Play:Int = 1, GS_HighIn:Int = 2, GS_High:Int = 3, GS_Achi:Int = 4
Global GameState:Int = GS_MainMenu

Global TitleImage:TImage = LoadImage("Data/gfx/Title.png")
Global MenuButtons:TImage = LoadAnimImage("Data/gfx/MenuButtons.png", 256, 64, 0, 10)
Global SndButton:TImage = LoadAnimImage("Data/gfx/SndButton.png", 64, 64, 0, 2)
Global Sky:TImage = LoadImage("Data/gfx/Sky.png")
Global BG:TImage = LoadAnimImage("Data/gfx/Terrain.png", 1536, 512, 0, 3)
Global Cursor:TImage = LoadImage("Data/gfx/cur.png")
Global bmax:TImage = LoadImage("Data/gfx/bmax.png")
SetImageHandle(Cursor, 0, 0)
Global Cross:TImage = LoadAnimImage("Data/gfx/Cross.png", 64, 64, 0, 4)

Local tmpP:TPixmap = CreatePixmap(1, 1, PF_BGRA8888)
tmpP.ClearPixels($FFFFFFFF)
Global CollPix:TImage = LoadImage(tmpP)

Global Pilz:TImage = LoadImage("Data/gfx/Pilz.png")
Global Krische:TImage = LoadImage("Data/gfx/Kirsch.png")
Global Apfel:TImage = LoadImage("Data/gfx/Apfel.png")
Global Karotte:TImage = LoadImage("Data/gfx/Rbe.png")
Global Huhn:TImage = LoadImage("Data/gfx/Huhn.png")
?Win32
	SetImageFont(LoadImageFont(getenv_("windir") + "\fonts\" + "Arial.ttf", 24))
?Linux
	SetImageFont(LoadImageFont("/usr/share/fonts/truetype/freefont/FreeSans.ttf", 24))
?


Global Snd_high:TSound = LoadSound("Data/sfx/high.ogg")
Global Snd_klick:TSound = LoadSound("Data/sfx/klick.ogg")
Global Snd_noshot:TSound = LoadSound("Data/sfx/noshot.ogg")
Global Snd_peng:TSound = LoadSound("Data/sfx/peng.ogg")
Global Snd_reload:TSound = LoadSound("Data/sfx/reload.ogg")
Global Snd_vote:TSound = LoadSound("Data/sfx/vote.ogg")
Global SoundOn:Int = True

Global Points:Int, Time:Int, PlayerName:String = getenv_("USERNAME")
Global Scroll:Int, Scale:Float[] = [.25, .5, 1.0]
Global Weapons:TGun[] = [TGun_Cherry.Create()], AktWeapon:TGun = Weapons[0]

LoadOptions()
THighscore.Load()

OnEnd(THighscore.Save)
OnEnd(SaveOptions)
OnEnd(Vote)

SetColor(255, 255, 255)
SetClsColor(0, 0, 0)
SetBlend(ALPHABLEND)
MoveMouse(gfx_w *.5, gfx_h *.55)

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	md1 = MouseDown(1)
	md2 = MouseDown(2)

	Select GameState
		Case GS_MainMenu; Run_MainMenu()
		Case GS_Play; Run_Play()
		Case GS_HighIn; Run_HighIn()
		Case GS_High; Run_High()
		Case GS_Achi; Run_Achi()
	End Select

	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Function Run_MainMenu()

	DrawBG()
	DrawImage(TitleImage, gfx_w *.5, gfx_h *.1)
	DrawImage(bmax, bmax.width *.75, gfx_h - bmax.height *.5)

	'* Spielen
	If ButtonImg(MenuButtons, 0, gfx_w *.5, gfx_h *.25) Then
		ResetGame()
		GameState = GS_Play
	EndIf
	
	'* Highscore
	If ButtonImg(MenuButtons, 2, gfx_w *.5, gfx_h *.45) Then
		GameState = GS_High
	EndIf
	
	'* Errungenschaften
	If ButtonImg(MenuButtons, 4, gfx_w *.5, gfx_h *.65) Then
		GameState = GS_Achi
	EndIf
	
	'* Beenden
	If ButtonImg(MenuButtons, 6, gfx_w *.5, gfx_h *.85) Then
		End
	EndIf
	
	'* Sound Ein/Aus
	If ButtonImg(SndButton, 0, gfx_w - SndButton.width, gfx_h - SndButton.height) Then
		SoundOn:~True
	EndIf
	DrawText(AnAus(SoundOn), gfx_w - SndButton.width, gfx_h - SndButton.height *.25)
	
	DrawImage(Cursor, mx, my)
		
End Function

Function ResetGame()
	Points = 0
	Time = ms + 90500 '* 1:30'50	
	Scroll = 0
	TEnemy.Generate()
	TRecipe.Random()
End Function

Function Run_Play()

	'* Spiel vorbei!
	If Time - ms <= 0 Then
		FlushKeys()
		TEnemy.Clear()
		GameState = GS_HighIn
		Return
	EndIf
	
	If mx < gfx_w *.2 And Scroll < 256 Then Scroll:+5
	If mx < gfx_w *.1 And Scroll < 256 Then Scroll:+10
	
	If mx > gfx_w *.8 And Scroll > - 256 Then Scroll:-5
	If mx > gfx_w *.9 And Scroll > - 256 Then Scroll:-10
	
	TileImage(Sky, 0, gfx_h *.5)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[0], gfx_h *.5, 0)
	TEnemy.DrawAll(0)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[1], gfx_h *.5, 1)
	TEnemy.DrawAll(1)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[2], gfx_h *.5, 2)
	TEnemy.DrawAll(2)

	DrawText(MakeTime(Time - ms), gfx_w *.02, gfx_h *.05, 0)
	DrawText(Points, gfx_w *.02, gfx_h *.1, 0)
	
	TRecipe.Akt.Draw()
	
	If mh2 Then AktWeapon.Reload()
	If mh1 Then AktWeapon.Fire(mx, my)
	
	If KeyDown(KEY_SPACE) Then Points:+5
	
	AktWeapon.Draw()
	DrawImage(Cross, mx, my, 2)
	
	
End Function

Function Run_HighIn()

	DrawBG()
	DrawText(">" + PlayerName + "<", gfx_w *.5, gfx_h *.5)
	Local c:Int = GetChar()
	If c > 31 And PlayerName.Length < 16 Then PlayerName:+Chr(c)
	
	If KeyHit(KEY_BACKSPACE) And PlayerName.Length > 0 Then PlayerName = PlayerName[..PlayerName.Length - 1]
	If KeyHit(KEY_ENTER) Then
		THighScore.Add(PlayerName, Points)
		Play_Sound(Snd_high)
		GameState = GS_High
	EndIf
	
End Function

Function Run_High()

	DrawBG()
	THighscore.Draw()

	'* Zurck
	If ButtonImg(MenuButtons, 8, gfx_w *.5, gfx_h *.85) Then
		GameState = GS_MainMenu
	EndIf
	
	DrawImage(Cursor, mx, my)
	
End Function

Function Run_Achi()

	DrawBG()
	
	DrawText("Diese Funktionalitt ist aus kostengrnden entfallen!", gfx_w *.5, gfx_h *.5)

	'* Zurck
	If ButtonImg(MenuButtons, 8, gfx_w *.5, gfx_h *.85) Then
		GameState = GS_MainMenu
	EndIf
	
	DrawImage(Cursor, mx, my)
		
End Function

Function DrawBG()
	TileImage(Sky, 0, gfx_h *.5)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[0], gfx_h *.5, 0)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[1], gfx_h *.5, 1)
	DrawImage(BG, gfx_w *.5 + Scroll * Scale[2], gfx_h *.5, 2)
End Function

Function Vote() ' OR DIE !!!
	If SoundOn Then
		Delay(500)
		Play_Sound(Snd_vote)
		Delay(1800)
	EndIf
End Function
